#TEMPLATE (CapFlash, 'Capitalize Templates (Legacy) - Sterling Data')
#!
#! Copyright 2001 Sterling Data Services
#! Version 1.0
#! Freeware
#! For more products and demos visit:
#! http://www.sterlingdata.com
#!
#!
#EXTENSION (CapProc, 'CapFlash - Capitalize text fields using a process'), PROCEDURE,hlp('~TemplatePrompts')
#DISPLAY('')
#DISPLAY('CapFlash - Copyright 2001 Sterling Data')
#DISPLAY('Freeware from www.sterlingdata.com')
#DISPLAY('')
#DISPLAY('If you make any improvements please let me know')
#DISPLAY('mike@sterlingdata.com')
#DISPLAY('')
#SHEET
#TAB('Capitalize Options')
#DISPLAY('')
#DISPLAY('')
#PREPARE
  #IF(NOT %DefsLoaded)
    #SET(%DefsLoaded, 1)
    #ADD(%CapLowerWords,1)
    #SET(%CapLowerWord, 'del')
    #ADD(%CapLowerWords,2)
    #SET(%CapLowerWord, 'de')
    #ADD(%CapLowerWords,3)
    #SET(%CapLowerWord, 'la')
    #ADD(%CapUpperWords,1)
    #SET(%CapUpperWord, 'ABC')
    #ADD(%CapUpperWords,2)
    #SET(%CapUpperWord, 'AFB')
    #ADD(%CapUpperWords,3)
    #SET(%CapUpperWord, 'USA')
    #ADD(%CapUpperWords,4)
    #SET(%CapUpperWord, 'U.S.A.')
    #ADD(%CapUpperWords,5)
    #SET(%CapUpperWord, 'BBS')
    #ADD(%CapUpperWords,6)
    #SET(%CapUpperWord, 'UG')
    #ADD(%CapUpperWords,7)
    #SET(%CapUpperWord, 'IBM')
    #ADD(%CapUpperWords,8)
  #ENDIF
#ENDPREPARE
#PROMPT ('Exclude Memos', CHECK), %CapMemoExclude, REQ,default(1)
#DISPLAY('')
  #BUTTON ('Words which are always lower case: '), MULTI(%CapLowerWords,%CapLowerWord), AT(10,, 180)
    #PROMPT ('Word to keep as lower :', @s50), %CapLowerWord,REQ
    #DISPLAY('')
  #ENDBUTTON
#DISPLAY('')
#DISPLAY('')
  #BUTTON ('Words which are always UPPER case: '), MULTI(%CapupperWords,%CapUpperWord), AT(10,, 180)
    #PROMPT ('Word to keep as UPPER :', @s50), %CapUpperWord,REQ
    #DISPLAY('')
  #ENDBUTTON
#DISPLAY('')
#DISPLAY('')
  #BUTTON ('Fields to exclude from Capitalization: '), MULTI(%CapExclFields,%CapExclField), AT(10,, 180)
    #PROMPT ('Field to exclude :', FIELD), %CapExclField,REQ
    #DISPLAY('')
  #ENDBUTTON
#DISPLAY('')
#DISPLAY('A typical field to exclude from capitalizing would be the')
#DISPLAY('state field')
#DISPLAY('')
#DISPLAY('')
#BOXED('') WHERE(%FALSE), AT(0,0,0,0)
  #PROMPT('',@N1), %DefsLoaded, AT(0,0,0,0)
#ENDBOXED
#ENDTAB
#ENDSHEET

#LOCALDATA
I  Long
L  Long
CapString  String(500)
CapString2  String(100)
CapPartWord STRING(20)
J   BYTE
WordPos BYTE
PartName    STRING(80),DIM(4)
#ENDLOCALDATA

#ATSTART
#ENDAT


#AT(%ProcedureRoutines)
CapFlash    Routine
           clear(PartName[])
           WordPos=1
           J=1
           L = Len(Clip(CapString))
           If L
            CapString[1] = Upper(CapString[1])
           End
           If L >= 2
               Loop I = 2 to L
                 If CapString[I-1] <> ' '
                   CapString[I] = Lower(CapString[I])
                   if I = L
                   if WordPos <=4
                     PartName[WordPos] = CapString[J : I]
                     CapPartWord=PartName[WordPos]
                     if upper(CapPartWord[1:3]) = 'MCL'
                            CapString[J : (J+2)] = 'McL'
                     .
                     if upper(CapPartWord[1:3]) = 'MAC'
                            CapString[J : (J+2)] = 'Mac'
                     .
                     if upper(CapPartWord[1:2]) = 'O'''
                            CapString[J+2] = upper(CapString[J+2])
                     .
                     capstring2=PartName[WordPos]
                     #FOR(%CapLowerWords)
                     if upper(PartName[WordPos]) = upper('%CapLowerWord')
                            CapString[J : I] = lower('%CapLowerWord')
                     .
                     #ENDFOR
                     #FOR(%CapUpperWords)
                     if upper(PartName[WordPos]) = upper('%CapUpperWord')
                            CapString[J : I] = upper('%CapUpperWord')
                     .
                     #ENDFOR
                     WordPos+=1
                     J=I
                   .

                   .
                 Else
                   CapString[I] = Upper(CapString[I])
                   if WordPos <=4
                     PartName[WordPos] = CapString[J : (I-2)]
                     CapPartWord=PartName[WordPos]
                     if upper(CapPartWord[1:3]) = 'MCL'
                            CapString[J : (J+2)] = 'McL'
                     .
                     if upper(CapPartWord[1:3]) = 'MAC'
                            CapString[J : (J+2)] = 'Mac'
                     .
                     if upper(CapPartWord[1:2]) = 'O'''
                            CapString[J+2] = upper(CapString[J+2])
                     .
                     capstring2=PartName[WordPos]
                     #FOR(%CapLowerWords)
                     if upper(PartName[WordPos]) = upper('%CapLowerWord')
                            CapString[J : (I-2)] = lower('%CapLowerWord')
                     .
                     #ENDFOR
                     #FOR(%CapUpperWords)
                     if upper(PartName[WordPos]) = upper('%CapUpperWord')
                            CapString[J : (I-2)] = upper('%CapUpperWord')
                     .
                     #ENDFOR
                     WordPos+=1
                     J=I
                   .
                 End
               End
            End
#ENDAT

#AT(%ProcessActivity)
#DECLARE(%CapSkipField)
#FIX (%File, %Primary)
#FOR(%Field)
#SET(%CapSkipField,0)
#FOR(%CapExclFields)
  #IF(%CapExclField = %Field)
       #SET(%CapSkipField,1)
       #BREAK
  #ENDIF
#ENDFOR
#IF(%CapSkipField=1)
   #CYCLE
#ENDIF

      #IF(%FieldType <> 'STRING')
             #IF(%FieldType <> 'MEMO')
                 #IF(%FieldType <> 'CSTRING')
                     #IF(%FieldType <> 'PSTRING')
                       #CYCLE
      #ENDIF  #ENDIF  #ENDIF  #ENDIF
      #IF(%FieldType = 'MEMO')
         #IF(%CapMemoExclude)
            #CYCLE
         #ENDIF
      #ENDIF
CapString=%Field
do CapFlash
%Field=CapString

#ENDFOR



#ENDAT

